/************************************************************
**	File:	sample.cpp
**	Author:	
**			HJ
**		      
**	Description:
**		Sample application for Comsync/PCI
**		
**      
**	Revision history:
**		Original:	07/03/09
**         
**	THIS IS THE UNPUBLISHED PROPRIETARY SOURCE CODE OF CONNECT TECH INC.
**	The copyright notice above does not evidence any actual or intended
**	publication of such source code.
**      
**	This module contains Proprietary Information of Connect Tech, Inc
**	and should be treated as Confidential.
************************************************************/


#include "stdafx.h"
#include <windows.h>
#include <winioctl.h>
#include "cspci_pset.h"

#define BUF_SIZE (1024*64 - 1)

#define packetSize 100


#define LOOPBACK 
//#define ASYNC
//#define MONO_SYNC
//#define HDLC
#define BI_SYNC
//#define WAIT_CTS
//#define USE_CRC
#define WRITE_DELAY 200

typedef struct
{
	HANDLE			hDriver;
	
}PORT_CONTEXT, *PPORT_CONTEXT;

DWORD WINAPI
 ReadThread(
    PPORT_CONTEXT	pContext
    );

DWORD WINAPI
 WriteThread(
    PPORT_CONTEXT	pContext
    );

DWORD WINAPI startWrite(PPORT_CONTEXT	pContext);


int main(int argc, char* argv[])
{
	HANDLE hWriteThread;
	HANDLE hReadThread;
	DWORD dwBytesReturned;  	
	BOOL bResult; 
	BHN_PortSettings DevCfgInfo;	
	DWORD dwThreadStatId;
	PORT_CONTEXT threadContext;	
	ULONG errNo=0;
	
	threadContext.hDriver = CreateFile(
		"\\\\.\\Comsync01",               // name of Comsync port to open
		GENERIC_READ | GENERIC_WRITE,   // open for receive and transmit
		0,                              // no sharing
		NULL,                           // no security
		OPEN_EXISTING,                  // device exists
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED, // normal access with overlapped I/O
		NULL);                          // no attr. template 
	
	if (threadContext.hDriver == INVALID_HANDLE_VALUE) 
	{		
		printf("Comsync port can not be opened, error %x\n", GetLastError());
		goto err_exit;
	}

	memset(&DevCfgInfo, 0, sizeof(DevCfgInfo)); // initialize the struture

	#ifdef ASYNC
	DevCfgInfo.smode.rx = SMODE_ASYNC;
	DevCfgInfo.smode.tx = SMODE_ASYNC;
	#endif

	#ifdef MONO_SYNC
	DevCfgInfo.smode.rx = SMODE_MONO;
	DevCfgInfo.smode.tx = SMODE_MONO;
	#endif

	#ifdef BI_SYNC
	DevCfgInfo.smode.rx = SMODE_BISYNC;
	DevCfgInfo.smode.tx = SMODE_BISYNC;
	#endif
	

	#ifdef HDLC
	DevCfgInfo.smode.rx = SMODE_HDLC;
	DevCfgInfo.smode.tx = SMODE_HDLC;
	#endif

	DevCfgInfo.line_mode = LM_V28;	

	DevCfgInfo.rxclk.enc_dec = NRZ;
	DevCfgInfo.rxclk.ref_freq = INT_REF_FREQ;
	DevCfgInfo.txclk.bps_error = 10000;
	DevCfgInfo.rxclk.bps = 9600;
	DevCfgInfo.rxclk.bps_frac = 0;

	#ifdef ASYNC
	DevCfgInfo.rxclk.async_div = 16;
	DevCfgInfo.rxclk.clk_tree.A = CLK_BRG0;	
	DevCfgInfo.rxclk.clk_tree.D = CTR_REF;	
	DevCfgInfo.txclk.async_div = 16;
	#else
	//DevCfgInfo.rxclk.clk_tree.A = CLK_RXC;
   DevCfgInfo.rxclk.clk_tree.A = CLK_BRG1;
	DevCfgInfo.rxclk.clk_tree.C = BRG_CTR1;
	DevCfgInfo.rxclk.clk_tree.D = CTR_REF;
	DevCfgInfo.rxclk.clk_pin = XC_INP;
	#endif

	DevCfgInfo.txclk.ref_freq = INT_REF_FREQ;
	DevCfgInfo.txclk.bps_error = 10000;
	DevCfgInfo.txclk.bps = 9600;
	DevCfgInfo.txclk.bps_frac = 0;

	DevCfgInfo.txclk.dpll_div = 0;
	DevCfgInfo.txclk.ctr_div = 0;
	DevCfgInfo.txclk.enc_dec = NRZ;

	#ifdef ASYNC
	DevCfgInfo.txclk.clk_tree.A = CLK_BRG0;	
	DevCfgInfo.txclk.clk_tree.D = CTR_REF;		
	#else
	DevCfgInfo.txclk.clk_tree.A = CLK_BRG0;
	DevCfgInfo.txclk.clk_tree.C = BRG_CTR0;
	DevCfgInfo.txclk.clk_tree.D = CTR_REF;
	DevCfgInfo.txclk.clk_pin = TXC_TXCLK;
	DevCfgInfo.tx_pre_idle.tx_idle = IDLE_MARK;
	#endif

	#ifdef HDLC
		#ifdef USE_HDLC_ADDR
		DevCfgInfo.hdlc.rx_addr_control = HDLC_RX_ADDR1_CONT0;
		DevCfgInfo.sync_addr.rx0 = 'A';  // HDLC address
		#endif
	#endif

	DevCfgInfo.duplex_mode = DUPLEX_FULL;

	#ifdef MONO_SYNC
	DevCfgInfo.sync_addr.tx0 = 0x16;
	DevCfgInfo.sync_addr.tx1 = 0;
	DevCfgInfo.sync_addr.tx_len = 8;
	DevCfgInfo.sync_addr.rx0 = 0x16;
	DevCfgInfo.sync_addr.rx1 = 0;
	DevCfgInfo.sync_addr.rx_len = 8;
	DevCfgInfo.sync_addr.strip_sync = 1;
	#endif

	#ifdef BI_SYNC
	DevCfgInfo.sync_addr.tx0 = 0x16;
	DevCfgInfo.sync_addr.tx1 = 0x16;
	DevCfgInfo.sync_addr.tx_len = 8;
	DevCfgInfo.sync_addr.rx0 = 0x16;
	DevCfgInfo.sync_addr.rx1 = 0x16;
	DevCfgInfo.sync_addr.rx_len = 8;
	DevCfgInfo.sync_addr.strip_sync = 1;
	DevCfgInfo.rx_strip_idle = 1;
	DevCfgInfo.tx_eof_idle = 1;
	#endif

	

	/* Data bits (number of) */
	DevCfgInfo.dbits.tx = 8;
	DevCfgInfo.dbits.rx = 8;

	#ifdef ASYNC
	/* Async Mode Transmitter (fractional) 1 Stop bits */
	DevCfgInfo.tx_frac_stop = 16;
	/* Async flow control settings */
	DevCfgInfo.async_settings.xoff = 0x13;
	DevCfgInfo.async_settings.xon = 0x11;
	DevCfgInfo.async_settings.sflow = 'n';
	DevCfgInfo.async_settings.hflow = 0;
	#endif

	#ifdef USE_CRC
	/* TX CRC */
	DevCfgInfo.crc.tx_type = CCITT;
	DevCfgInfo.crc.tx_mode |= CRC_TX_EOFM;
	DevCfgInfo.crc.tx_start = CRC_START_1;
	/* RX CRC */
	DevCfgInfo.crc.rx_type = CCITT;
	DevCfgInfo.crc.rx_start = CRC_START_1;
		#ifdef USE_CRC_ON_UNDERRUN
		DevCfgInfo.crc.tx_mode |= CRC_TX_UNDERRUN;
		#else
		DevCfgInfo.hdlc.tx_underrun = HDLC_UNDERRUN_ABORT_7;
		#endif
	#else
	DevCfgInfo.crc.tx_type = CRC_NONE;
	DevCfgInfo.crc.rx_type = CRC_NONE;
		#ifdef HDLC
		DevCfgInfo.hdlc.tx_underrun = HDLC_UNDERRUN_FLAG;
		#endif
	#endif
	
	bResult = DeviceIoControl(threadContext.hDriver,  // handle of communication port returned from CreateFile()
		(DWORD) IOCTL_COMSYNC_SET_CONFIGURATION,  // operation to perform
		&DevCfgInfo, //address  of the structure               
		sizeof(DevCfgInfo), // size of the structure
		&errNo, // no output from this operation
		sizeof(ULONG), // no output from this operation
		&dwBytesReturned, // discard count of bytes returned              
		NULL); // synchronous I/O


	if (!bResult || errNo)                 
	{		
		printf("IOCTL_COMSYNC_SET_CONFIGURATION failed, error %x\n", errNo);
		goto err_exit;
	}                 	

	
	hReadThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) ReadThread,
			(LPVOID) &threadContext, 0, &dwThreadStatId);

	if (!hReadThread)                 

	{		
		printf("CreateThread failed, error %x\n", GetLastError());
		goto err_exit;
	}

	hWriteThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) startWrite,
			(LPVOID) &threadContext, 0, &dwThreadStatId);

	if (!hWriteThread)                 

	{		
		printf("CreateThread failed, error %x\n", GetLastError());
		goto err_exit;
	}   

	while(1);


err_exit:

	if(threadContext.hDriver)
		CloseHandle(threadContext.hDriver);

	return 0;
}

DWORD WINAPI
 WriteThread(
    PPORT_CONTEXT	pContext
    )
{
	int i;
	ULONG				bytesSent[2];	
	BOOL				bResult;
	OVERLAPPED osWrite[2] = {0};	
	DWORD dwRes, ErrCodes[2];
	BYTE				outBuffer[2][BUF_SIZE];
	BYTE				writeNum = 0;
	LONG				loopCount = 0;
	
   osWrite[0].hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);	
   osWrite[1].hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);	

	for(i=11; i<packetSize-1; i++)		
	{
		outBuffer[0][i] = (BYTE) (i-11) % 26 + 0x41;		
		outBuffer[1][i] = (BYTE) (i-11) % 26 + 0x41;	
	}		
	outBuffer[0][i] = '\n';
	outBuffer[1][i] = '\n';
	sprintf(&outBuffer[writeNum][0],"%10.10d",	loopCount++);

	ErrCodes[writeNum] = ERROR_SUCCESS ;
	bytesSent[writeNum] = 0;

	bResult = 
		WriteFile(
		pContext->hDriver,       // returned handle of Comsync port, returned by CreateFile(FILE_FLAG_OVERLAPPED)
		outBuffer[writeNum],              // transmit buffer
		packetSize,                  // number of bytes to transmit
		&bytesSent[writeNum],     // number of bytes transmitted
		&osWrite[writeNum]               // event will be used later by WaitForMultipleObjects
	);
	if (!bResult)
	{
		ErrCodes[writeNum] = GetLastError() ;
	}
	writeNum = ~writeNum & 0x01;

	while(1)	
	{		
#ifdef WRITE_DELAY
		Sleep(WRITE_DELAY);
#endif
		sprintf(&outBuffer[writeNum][0],"%10.10d",	loopCount++);
		if(loopCount < 0)
			loopCount = 0;
		ErrCodes[writeNum] = ERROR_SUCCESS ;
		bytesSent[writeNum] = 0;
		bResult = 
			WriteFile(
			pContext->hDriver,       // returned handle of Comsync port, returned by CreateFile(FILE_FLAG_OVERLAPPED)
			outBuffer[writeNum],              // transmit buffer
			packetSize,                  // number of bytes to transmit
			&bytesSent[writeNum],     // number of bytes transmitted
			&osWrite[writeNum]               // event will be used later by WaitForMultipleObjects
		);
		if (!bResult)
		{
			ErrCodes[writeNum] = GetLastError() ;
		}
		
		writeNum = ~writeNum & 0x01;

		if (ErrCodes[writeNum] == ERROR_IO_PENDING)
		{    
			dwRes = WaitForMultipleObjects(1, &osWrite[writeNum].hEvent, FALSE, INFINITE);

			bResult =
				GetOverlappedResult(
				pContext->hDriver,
				&osWrite[writeNum],
				&bytesSent[writeNum],
				TRUE
				) ;

			if (!bResult)
			{										
				printf("WriteFile failed ErrCodes 0x%x\n",GetLastError());
			}
		}
		//printf("sent %d\n",bytesSent[writeNum]);
	}
	return 1;
}

BOOL 	bHunt = FALSE;
BOOL 	bHuntEnd = FALSE;

DWORD WINAPI
 ReadThread(
    PPORT_CONTEXT	pContext
    )
{
	
	ULONG				bytesRecv;	
	BOOL				bResult;
	OVERLAPPED osRead = {0};
	DWORD dwRes, ErrCodes;
	ULONG i;
	BOOL msgRdy = FALSE;
	
	DWORD dwBytesReturned;  
	HANDLE hArray[1];
	

// define only one from ASYNC, MONO_SYNC and HDLC
#ifdef LOOPBACK 
	DWORD RecvSize = packetSize;	
#else
	DWORD RecvSize = 1000;	
#endif
	BYTE				inBuffer[BUF_SIZE];
	
   osRead.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	
	
	while(1)	
	{		
		ErrCodes = ERROR_SUCCESS ;
		memset(inBuffer,0,packetSize);
		bytesRecv=0;	
		
		bResult = ReadFile(
							pContext->hDriver,                    // returned handle of Comsync port, returned by CreateFile(FILE_FLAG_OVERLAPPED)
							inBuffer,              // receive buffer
							RecvSize,                  // number of bytes to receive 
							&bytesRecv,     // number of bytes received
							&osRead               // event will be used later by WaitForMultipleObjects
							);
		if (!bResult)
		{			
			
			if (GetLastError() == ERROR_IO_PENDING)
			{    
				dwRes = WaitForMultipleObjects(1, &osRead.hEvent, FALSE, INFINITE);

				bResult =
					GetOverlappedResult(
					pContext->hDriver ,
					&osRead,
					&bytesRecv,
					TRUE
					) ;

				if (!bResult)
				{
					ErrCodes = GetLastError() ;
				}
			}
			
			if(bytesRecv)
			{
				for(i=0;i<bytesRecv;i++)
				{					
					if(inBuffer[i] == 0xff || inBuffer[i] == 0x16)
					{									
						bHunt = TRUE;							
					}
					if(inBuffer[i] != 0xff) 
					{
						printf("%c",inBuffer[i]);
						bHuntEnd = TRUE;
					}
				}
				
			}
			if (ErrCodes != ERROR_SUCCESS)
			{
				printf("ReadFile failed\n");
			}
			
		}
		else
		{
			if(bytesRecv)
			{
				for(i=0;i<bytesRecv;i++)
				{					
					if(inBuffer[i] == 0xff || inBuffer[i] == 0x16) 
					{						
						bHunt = TRUE;						
					}
					
					if(inBuffer[i] != 0xff) 
					{
						printf("%c",inBuffer[i]);
						bHuntEnd = TRUE;
					}
				}
				
			}
		}
		
		if(bHunt && bHuntEnd)
		{
			hArray[0] = osRead.hEvent;
			bResult = DeviceIoControl(pContext->hDriver,
								IOCTL_COMSYNC_FORCE_HUNT, // operation to perform
							   NULL, //address  of the input buffer containing event mask   
							   0, // size of the input buffer containing event mask   
							   NULL, //address  of the output buffer containing event mask
							   0, // size of the output buffer containing event mask
							   &dwBytesReturned, // size of bytes returned from driver for output buffer
							   &osRead);
			if (!bResult)                 
			{
				if (GetLastError() == ERROR_IO_PENDING)
            {					
					WaitForMultipleObjects(1, hArray, FALSE, INFINITE);					
				}				
			}
			
			bHunt = FALSE;
			bHuntEnd = FALSE;
		}
		msgRdy = TRUE;
	}

	return 1;
}
DWORD WINAPI startWrite(PPORT_CONTEXT	pContext)
{	
	DWORD dwBytesReturned;  
	BOOL bResult;
	UCHAR ctsStat;
	OVERLAPPED osRead = {0};
	DWORD ret;

	osRead.hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

#ifdef LOOPBACK
	bResult = DeviceIoControl(pContext->hDriver,  // handle of communication port returned from CreateFile()
		(DWORD) IOCTL_COMSYNC_INTERNAL_LOOPBACK,  // operation to perform
		NULL, //address  of the structure               
		sizeof(ULONG), // size of the structure
		NULL, // no output from this operation
		0, // no output from this operation
		&dwBytesReturned, // discard count of bytes returned              
		NULL); 

	if (!bResult)                 
	{				
		printf("IOCTL_COMSYNC_INTERNAL_LOOPBACK failed, error %x\n", GetLastError());				
	}  				
#endif

#ifdef WAIT_CTS
	while(1)
	{
		bResult = DeviceIoControl(pContext->hDriver,
							   IOCTL_COMSYNC_GET_CTS, // operation to perform
							   NULL, //address  of the input buffer containing event mask   
							   0, // size of the input buffer containing event mask   
							   &ctsStat, //address  of the output buffer containing event mask
							   sizeof(UCHAR), // size of the output buffer containing event mask
							   &dwBytesReturned, //address  of the output buffer
							   &osRead
							   );

		if (!bResult)                 
		{
			if (GetLastError() == ERROR_IO_PENDING)
			{							
				ret = WaitForSingleObject(osRead.hEvent, INFINITE);					
				if(ret == WAIT_OBJECT_0 )
					if(ctsStat){
						WriteThread(pContext);
						break;
					}
					else
						continue;
			}
		}
		else if (GetLastError() == ERROR_SUCCESS) {
			if(ctsStat) {
					WriteThread(pContext);
					break;
			}
				else
					continue;				
		}
		else
		{
			printf("IOCTL_COMSYNC_EVENT_DCD failed err %x\n",GetLastError());
			break;
		}
		
	}
#else
	WriteThread(pContext);
#endif

	return 0;
}